CREATE SCHEMA "public";

CREATE SEQUENCE "public".usuario_codigo_seq1 START WITH 1;

CREATE TABLE "public".usuario ( 
	codigo               serial  NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	paterno              varchar(150)   ,
	materno              varchar(150)   ,
	nombres              varchar(150)   ,
	direccion            varchar(150)   ,
	telefono             varchar(50)   ,
	correo               varchar(100)   ,
	login                varchar(50)   ,
	pass                 char(32)   ,
	CONSTRAINT pk_usuario_codigo_0 PRIMARY KEY ( codigo )
 );

CREATE OR REPLACE FUNCTION public.fn_crearusuario(p_paterno character varying, p_materno character varying, p_nombres character varying, p_direccion character varying, p_telefono character varying, p_correo character varying, p_pass character varying)
 RETURNS TABLE(r_login character varying)
 LANGUAGE plpgsql
AS $function$
Declare
Begin
    INSERT INTO usuario( 
        paterno, 
        materno, 
        nombres, 
        direccion, 
        telefono, 
        correo, 
        login, 
        pass) 
    VALUES ( 
        p_paterno, 
        p_materno, 
        p_nombres, 
        p_direccion, 
        p_telefono, 
        p_correo, 
        ((SELECT LEFT(p_nombres,1) )||p_paterno)::varchar, 
        (SELECT MD5(p_pass))::char(32)
     );
     return query 
     select ((SELECT LEFT(p_nombres,1) )||p_paterno)::varchar;
end;
$function$

CREATE OR REPLACE FUNCTION public.fn_iniciosesion(p_usuario character varying, p_pass character varying)
 RETURNS TABLE(r_codigo integer)
 LANGUAGE plpgsql
AS $function$
Begin
    RETURN QUERY
	select codigo
    from usuario 
    where login like p_usuario and pass like (select MD5(p_pass));
end;
$function$

